Index: uspace/drv/nic/ne2k/dp8390.h
===================================================================
--- uspace/drv/nic/ne2k/dp8390.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
+++ uspace/drv/nic/ne2k/dp8390.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -0,0 +1,277 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * Copyright (c) 2011 Martin Decky
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/*
+ * This code is based upon the NE2000 driver for MINIX,
+ * distributed according to a BSD-style license.
+ *
+ * Copyright (c) 1987, 1997, 2006 Vrije Universiteit
+ * Copyright (c) 1992, 1994 Philip Homburg
+ * Copyright (c) 1996 G. Falzoni
+ *
+ */
+
+/** @addtogroup drv_ne2k
+ *  @{
+ */
+
+/** @file
+ *  DP8390 network interface definitions.
+ */
+
+#ifndef __NET_NETIF_DP8390_H__
+#define __NET_NETIF_DP8390_H__
+
+#include <fibril_synch.h>
+#include <nic.h>
+#include <ddf/interrupt.h>
+
+/** Input/output size */
+#define NE2K_IO_SIZE  0x0020
+
+/* NE2000 implementation. */
+
+/** NE2000 Data Register */
+#define NE2K_DATA  0x0010
+
+/** NE2000 Reset register */
+#define NE2K_RESET  0x001f
+
+/** NE2000 data start */
+#define NE2K_START  0x4000
+
+/** NE2000 data size */
+#define NE2K_SIZE  0x4000
+
+/** NE2000 retry count */
+#define NE2K_RETRY  0x1000
+
+/** NE2000 error messages rate limiting */
+#define NE2K_ERL  10
+
+/** Minimum Ethernet packet size in bytes */
+#define ETH_MIN_PACK_SIZE  60
+
+/** Maximum Ethernet packet size in bytes */
+#define ETH_MAX_PACK_SIZE_TAGGED  1518
+
+/* National Semiconductor DP8390 Network Interface Controller. */
+
+/** Page 0, for reading */
+#define DP_CR     0x00  /**< Command Register */
+#define DP_CLDA0  0x01  /**< Current Local DMA Address 0 */
+#define DP_CLDA1  0x02  /**< Current Local DMA Address 1 */
+#define DP_BNRY   0x03  /**< Boundary Pointer */
+#define DP_TSR    0x04  /**< Transmit Status Register */
+#define DP_NCR    0x05  /**< Number of Collisions Register */
+#define DP_FIFO   0x06  /**< FIFO */
+#define DP_ISR    0x07  /**< Interrupt Status Register */
+#define DP_CRDA0  0x08  /**< Current Remote DMA Address 0 */
+#define DP_CRDA1  0x09  /**< Current Remote DMA Address 1 */
+#define DP_RSR    0x0c  /**< Receive Status Register */
+#define DP_CNTR0  0x0d  /**< Tally Counter 0 */
+#define DP_CNTR1  0x0e  /**< Tally Counter 1 */
+#define DP_CNTR2  0x0f  /**< Tally Counter 2 */
+
+/** Page 0, for writing */
+#define DP_PSTART  0x01  /**< Page Start Register*/
+#define DP_PSTOP   0x02  /**< Page Stop Register */
+#define DP_TPSR    0x04  /**< Transmit Page Start Register */
+#define DP_TBCR0   0x05  /**< Transmit Byte Count Register 0 */
+#define DP_TBCR1   0x06  /**< Transmit Byte Count Register 1 */
+#define DP_RSAR0   0x08  /**< Remote Start Address Register 0 */
+#define DP_RSAR1   0x09  /**< Remote Start Address Register 1 */
+#define DP_RBCR0   0x0a  /**< Remote Byte Count Register 0 */
+#define DP_RBCR1   0x0b  /**< Remote Byte Count Register 1 */
+#define DP_RCR     0x0c  /**< Receive Configuration Register */
+#define DP_TCR     0x0d  /**< Transmit Configuration Register */
+#define DP_DCR     0x0e  /**< Data Configuration Register */
+#define DP_IMR     0x0f  /**< Interrupt Mask Register */
+
+/** Page 1, read/write */
+#define DP_PAR0  0x01  /**< Physical Address Register 0 */
+#define DP_PAR1  0x02  /**< Physical Address Register 1 */
+#define DP_PAR2  0x03  /**< Physical Address Register 2 */
+#define DP_PAR3  0x04  /**< Physical Address Register 3 */
+#define DP_PAR4  0x05  /**< Physical Address Register 4 */
+#define DP_PAR5  0x06  /**< Physical Address Register 5 */
+#define DP_CURR  0x07  /**< Current Page Register */
+#define DP_MAR0  0x08  /**< Multicast Address Register 0 */
+#define DP_MAR1  0x09  /**< Multicast Address Register 1 */
+#define DP_MAR2  0x0a  /**< Multicast Address Register 2 */
+#define DP_MAR3  0x0b  /**< Multicast Address Register 3 */
+#define DP_MAR4  0x0c  /**< Multicast Address Register 4 */
+#define DP_MAR5  0x0d  /**< Multicast Address Register 5 */
+#define DP_MAR6  0x0e  /**< Multicast Address Register 6 */
+#define DP_MAR7  0x0f  /**< Multicast Address Register 7 */
+
+/* Bits in Command Register */
+#define CR_STP       0x01  /**< Stop (software reset) */
+#define CR_STA       0x02  /**< Start (activate NIC) */
+#define CR_TXP       0x04  /**< Transmit Packet */
+#define CR_DMA       0x38  /**< Mask for DMA control */
+#define CR_DM_NOP    0x00  /**< DMA: No Operation */
+#define CR_DM_RR     0x08  /**< DMA: Remote Read */
+#define CR_DM_RW     0x10  /**< DMA: Remote Write */
+#define CR_DM_SP     0x18  /**< DMA: Send Packet */
+#define CR_DM_ABORT  0x20  /**< DMA: Abort Remote DMA Operation */
+#define CR_PS        0xc0  /**< Mask for Page Select */
+#define CR_PS_P0     0x00  /**< Register Page 0 */
+#define CR_PS_P1     0x40  /**< Register Page 1 */
+#define CR_PS_P2     0x80  /**< Register Page 2 */
+#define CR_PS_T1     0xc0  /**< Test Mode Register Map */
+
+/* Bits in Interrupt State Register */
+#define ISR_PRX  0x01  /**< Packet Received with no errors */
+#define ISR_PTX  0x02  /**< Packet Transmitted with no errors */
+#define ISR_RXE  0x04  /**< Receive Error */
+#define ISR_TXE  0x08  /**< Transmit Error */
+#define ISR_OVW  0x10  /**< Overwrite Warning */
+#define ISR_CNT  0x20  /**< Counter Overflow */
+#define ISR_RDC  0x40  /**< Remote DMA Complete */
+#define ISR_RST  0x80  /**< Reset Status */
+
+/* Bits in Interrupt Mask Register */
+#define IMR_PRXE  0x01  /**< Packet Received Interrupt Enable */
+#define IMR_PTXE  0x02  /**< Packet Transmitted Interrupt Enable */
+#define IMR_RXEE  0x04  /**< Receive Error Interrupt Enable */
+#define IMR_TXEE  0x08  /**< Transmit Error Interrupt Enable */
+#define IMR_OVWE  0x10  /**< Overwrite Warning Interrupt Enable */
+#define IMR_CNTE  0x20  /**< Counter Overflow Interrupt Enable */
+#define IMR_RDCE  0x40  /**< DMA Complete Interrupt Enable */
+
+/* Bits in Data Configuration Register */
+#define DCR_WTS        0x01  /**< Word Transfer Select */
+#define DCR_BYTEWIDE   0x00  /**< WTS: byte wide transfers */
+#define DCR_WORDWIDE   0x01  /**< WTS: word wide transfers */
+#define DCR_BOS        0x02  /**< Byte Order Select */
+#define DCR_LTLENDIAN  0x00  /**< BOS: Little Endian */
+#define DCR_BIGENDIAN  0x02  /**< BOS: Big Endian */
+#define DCR_LAS        0x04  /**< Long Address Select */
+#define DCR_BMS        0x08  /**< Burst Mode Select */
+#define DCR_AR         0x10  /**< Autoinitialize Remote */
+#define DCR_FTS        0x60  /**< Fifo Threshold Select */
+#define DCR_2BYTES     0x00  /**< 2 bytes */
+#define DCR_4BYTES     0x40  /**< 4 bytes */
+#define DCR_8BYTES     0x20  /**< 8 bytes */
+#define DCR_12BYTES    0x60  /**< 12 bytes */
+
+/* Bits in Transmit Configuration Register */
+#define TCR_CRC        0x01  /**< Inhibit CRC */
+#define TCR_ELC        0x06  /**< Encoded Loopback Control */
+#define TCR_NORMAL     0x00  /**< ELC: Normal Operation */
+#define TCR_INTERNAL   0x02  /**< ELC: Internal Loopback */
+#define TCR_0EXTERNAL  0x04  /**< ELC: External Loopback LPBK=0 */
+#define TCR_1EXTERNAL  0x06  /**< ELC: External Loopback LPBK=1 */
+#define TCR_ATD        0x08  /**< Auto Transmit Disable */
+#define TCR_OFST       0x10  /**< Collision Offset Enable (be nice) */
+
+/* Bits in Interrupt Status Register */
+#define TSR_PTX  0x01  /**< Packet Transmitted (without error) */
+#define TSR_DFR  0x02  /**< Transmit Deferred (reserved) */
+#define TSR_COL  0x04  /**< Transmit Collided */
+#define TSR_ABT  0x08  /**< Transmit Aborted */
+#define TSR_CRS  0x10  /**< Carrier Sense Lost */
+#define TSR_FU   0x20  /**< FIFO Underrun */
+#define TSR_CDH  0x40  /**< CD Heartbeat */
+#define TSR_OWC  0x80  /**< Out of Window Collision */
+
+/* Bits in Receive Configuration Register */
+#define RCR_SEP  0x01  /**< Save Errored Packets */
+#define RCR_AR   0x02  /**< Accept Runt Packets */
+#define RCR_AB   0x04  /**< Accept Broadcast */
+#define RCR_AM   0x08  /**< Accept Multicast */
+#define RCR_PRO  0x10  /**< Physical Promiscuous */
+#define RCR_MON  0x20  /**< Monitor Mode */
+
+/* Bits in Receive Status Register */
+#define RSR_PRX  0x01  /**< Packet Received Intact */
+#define RSR_CRC  0x02  /**< CRC Error */
+#define RSR_FAE  0x04  /**< Frame Alignment Error */
+#define RSR_FO   0x08  /**< FIFO Overrun */
+#define RSR_MPA  0x10  /**< Missed Packet */
+#define RSR_PHY  0x20  /**< Multicast Address Match */
+#define RSR_DIS  0x40  /**< Receiver Disabled */
+#define RSR_DFR  0x80  /**< In later manuals: Deferring */
+
+typedef struct {
+	/* Device configuration */
+	void *base_port; /**< Port assigned from ISA configuration **/
+	void *port;
+	void *data_port;
+	int irq;
+	nic_address_t mac;
+	
+	uint8_t start_page;  /**< Ring buffer start page */
+	uint8_t stop_page;   /**< Ring buffer stop page */
+	
+	/* Send queue */
+	struct {
+		bool dirty;    /**< Buffer contains a packet */
+		size_t size;   /**< Packet size */
+		uint8_t page;  /**< Starting page of the buffer */
+	} sq;
+	fibril_mutex_t sq_mutex;
+	fibril_condvar_t sq_cv;
+	
+	/* Driver run-time variables */
+	bool probed;
+	bool up;
+
+	/* Irq code with assigned addresses for this device */
+	irq_code_t code;
+
+	/* Copy of the receive configuration register */
+	uint8_t receive_configuration;
+
+	/* Device statistics */
+	// TODO: shouldn't be these directly in device.h - nic_device_stats?
+	uint64_t misses;     /**< Receive frame misses */
+	uint64_t underruns;  /**< FIFO underruns */
+	uint64_t overruns;   /**< FIFO overruns */
+} ne2k_t;
+
+extern int ne2k_probe(ne2k_t *);
+extern int ne2k_up(ne2k_t *);
+extern void ne2k_down(ne2k_t *);
+extern void ne2k_send(nic_t *, packet_t *);
+extern void ne2k_interrupt(nic_t *, uint8_t, uint8_t);
+extern packet_t *ne2k_alloc_packet(nic_t *, size_t);
+
+extern void ne2k_set_accept_mcast(ne2k_t *, int);
+extern void ne2k_set_accept_bcast(ne2k_t *, int);
+extern void ne2k_set_promisc_phys(ne2k_t *, int);
+extern void ne2k_set_mcast_hash(ne2k_t *, uint64_t);
+extern void ne2k_set_physical_address(ne2k_t *, const nic_address_t *address);
+
+#endif
+
+/** @}
+ */
Index: uspace/drv/nic/ne2k/ne2k.c
===================================================================
--- uspace/drv/nic/ne2k/ne2k.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
+++ uspace/drv/nic/ne2k/ne2k.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -0,0 +1,410 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * Copyright (c) 2011 Radim Vansa
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup drv_ne2k
+ * @brief Novell NE2000 NIC driver
+ * @{
+ */
+/**
+ * @file
+ * @brief Bridge between NICF, DDF and business logic for the NIC
+ */
+
+#include <stdio.h>
+#include <errno.h>
+#include <stdlib.h>
+#include <str_error.h>
+#include <async.h>
+#include "dp8390.h"
+
+#define NAME  "ne2k"
+
+/** Return the ISR from the interrupt call.
+ *
+ * @param[in] call The interrupt call.
+ *
+ */
+#define IRQ_GET_ISR(call)  ((int) IPC_GET_ARG2(call))
+
+/** Return the TSR from the interrupt call.
+ *
+ * @param[in] call The interrupt call.
+ *
+ */
+#define IRQ_GET_TSR(call)  ((int) IPC_GET_ARG3(call))
+
+#define DRIVER_DATA(dev) ((nic_t *) ((dev)->driver_data))
+#define NE2K(device) ((ne2k_t *) nic_get_specific(DRIVER_DATA(device)))
+
+/** NE2000 kernel interrupt command sequence.
+ *
+ */
+static irq_cmd_t ne2k_cmds_prototype[] = {
+	{
+		/* Read Interrupt Status Register */
+		.cmd = CMD_PIO_READ_8,
+		.addr = NULL,
+		.dstarg = 2
+	},
+	{
+		/* Mask supported interrupt causes */
+		.cmd = CMD_BTEST,
+		.value = (ISR_PRX | ISR_PTX | ISR_RXE | ISR_TXE | ISR_OVW |
+		    ISR_CNT | ISR_RDC),
+		.srcarg = 2,
+		.dstarg = 3,
+	},
+	{
+		/* Predicate for accepting the interrupt */
+		.cmd = CMD_PREDICATE,
+		.value = 4,
+		.srcarg = 3
+	},
+	{
+		/*
+		 * Mask future interrupts via
+		 * Interrupt Mask Register
+		 */
+		.cmd = CMD_PIO_WRITE_8,
+		.addr = NULL,
+		.value = 0
+	},
+	{
+		/* Acknowledge the current interrupt */
+		.cmd = CMD_PIO_WRITE_A_8,
+		.addr = NULL,
+		.srcarg = 3
+	},
+	{
+		/* Read Transmit Status Register */
+		.cmd = CMD_PIO_READ_8,
+		.addr = NULL,
+		.dstarg = 3
+	},
+	{
+		.cmd = CMD_ACCEPT
+	}
+};
+
+static void ne2k_interrupt_handler(ddf_dev_t *dev, ipc_callid_t iid,
+	ipc_call_t *call);
+
+static int ne2k_register_interrupt(nic_t *nic_data)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+
+	if (ne2k->code.cmdcount == 0) {
+		irq_cmd_t *ne2k_cmds = malloc(sizeof(ne2k_cmds_prototype));
+		if (ne2k_cmds == NULL) {
+			return ENOMEM;
+		}
+		memcpy(ne2k_cmds, ne2k_cmds_prototype, sizeof (ne2k_cmds_prototype));
+		ne2k_cmds[0].addr = ne2k->port + DP_ISR;
+		ne2k_cmds[3].addr = ne2k->port + DP_IMR;
+		ne2k_cmds[4].addr = ne2k_cmds[0].addr;
+		ne2k_cmds[5].addr = ne2k->port + DP_TSR;
+
+		ne2k->code.cmdcount = sizeof(ne2k_cmds_prototype) / sizeof(irq_cmd_t);
+		ne2k->code.cmds = ne2k_cmds;
+	}
+
+	int rc = register_interrupt_handler(nic_get_ddf_dev(nic_data),
+		ne2k->irq, ne2k_interrupt_handler, &ne2k->code);
+	return rc;
+}
+
+static ddf_dev_ops_t ne2k_dev_ops;
+
+static void ne2k_dev_cleanup(ddf_dev_t *dev)
+{
+	if (dev->driver_data != NULL) {
+		ne2k_t *ne2k = NE2K(dev);
+		if (ne2k) {
+			free(ne2k->code.cmds);
+		}
+		nic_unbind_and_destroy(dev);
+	}
+	if (dev->parent_sess != NULL) {
+		async_hangup(dev->parent_sess);
+		dev->parent_sess = NULL;
+	}
+}
+
+static int ne2k_dev_init(nic_t *nic_data)
+{
+	/* Get HW resources */
+	hw_res_list_parsed_t hw_res_parsed;
+	hw_res_list_parsed_init(&hw_res_parsed);
+	
+	int rc = nic_get_resources(nic_data, &hw_res_parsed);
+	
+	if (rc != EOK)
+		goto failed;
+	
+	if (hw_res_parsed.irqs.count == 0) {
+		rc = EINVAL;
+		goto failed;
+	}
+	
+	if (hw_res_parsed.io_ranges.count == 0) {
+		rc = EINVAL;
+		goto failed;
+	}
+	
+	if (hw_res_parsed.io_ranges.ranges[0].size < NE2K_IO_SIZE) {
+		rc = EINVAL;
+		goto failed;
+	}
+	
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+	ne2k->irq = hw_res_parsed.irqs.irqs[0];
+	
+	ne2k->base_port = (void *) (uintptr_t)
+	    hw_res_parsed.io_ranges.ranges[0].address;
+	
+	hw_res_list_parsed_clean(&hw_res_parsed);
+	
+	/* Enable port I/O */
+	if (pio_enable(ne2k->base_port, NE2K_IO_SIZE, &ne2k->port) != EOK)
+		return EADDRNOTAVAIL;
+	
+	
+	ne2k->data_port = ne2k->port + NE2K_DATA;
+	ne2k->receive_configuration = RCR_AB | RCR_AM;
+	ne2k->probed = false;
+	ne2k->up = false;
+	
+	/* Find out whether the device is present. */
+	if (ne2k_probe(ne2k) != EOK)
+		return ENOENT;
+	
+	ne2k->probed = true;
+	
+	rc = ne2k_register_interrupt(nic_data);
+	if (rc != EOK)
+		return EINVAL;
+	
+	return EOK;
+	
+failed:
+	hw_res_list_parsed_clean(&hw_res_parsed);
+	return rc;
+}
+
+void ne2k_interrupt_handler(ddf_dev_t *dev, ipc_callid_t iid, ipc_call_t *call)
+{
+	nic_t *nic_data = DRIVER_DATA(dev);
+	ne2k_interrupt(nic_data, IRQ_GET_ISR(*call), IRQ_GET_TSR(*call));
+
+	async_answer_0(iid, EOK);
+}
+
+static int ne2k_on_activating(nic_t *nic_data)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+
+	if (!ne2k->up) {
+		int rc = ne2k_up(ne2k);
+		if (rc != EOK) {
+			return rc;
+		}
+
+		nic_enable_interrupt(nic_data, ne2k->irq);
+	}
+	return EOK;
+}
+
+static int ne2k_on_stopping(nic_t *nic_data)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+
+	nic_disable_interrupt(nic_data, ne2k->irq);
+	ne2k->receive_configuration = RCR_AB | RCR_AM;
+	ne2k_down(ne2k);
+	return EOK;
+}
+
+static int ne2k_set_address(ddf_fun_t *fun, const nic_address_t *address)
+{
+	nic_t *nic_data = DRIVER_DATA(fun);
+	int rc = nic_report_address(nic_data, address);
+	if (rc != EOK) {
+		return EINVAL;
+	}
+	/* Note: some frame with previous physical address may slip to NIL here
+	 * (for a moment the filtering is not exact), but ethernet should be OK with
+	 * that. Some packet may also be lost, but this is not a problem.
+	 */
+	ne2k_set_physical_address((ne2k_t *) nic_get_specific(nic_data), address);
+	return EOK;
+}
+
+static int ne2k_on_unicast_mode_change(nic_t *nic_data,
+	nic_unicast_mode_t new_mode,
+	const nic_address_t *address_list, size_t address_count)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+	switch (new_mode) {
+	case NIC_UNICAST_BLOCKED:
+		ne2k_set_promisc_phys(ne2k, false);
+		nic_report_hw_filtering(nic_data, 0, -1, -1);
+		return EOK;
+	case NIC_UNICAST_DEFAULT:
+		ne2k_set_promisc_phys(ne2k, false);
+		nic_report_hw_filtering(nic_data, 1, -1, -1);
+		return EOK;
+	case NIC_UNICAST_LIST:
+		ne2k_set_promisc_phys(ne2k, true);
+		nic_report_hw_filtering(nic_data, 0, -1, -1);
+		return EOK;
+	case NIC_UNICAST_PROMISC:
+		ne2k_set_promisc_phys(ne2k, true);
+		nic_report_hw_filtering(nic_data, 1, -1, -1);
+		return EOK;
+	default:
+		return ENOTSUP;
+	}
+}
+
+static int ne2k_on_multicast_mode_change(nic_t *nic_data,
+	nic_multicast_mode_t new_mode,
+	const nic_address_t *address_list, size_t address_count)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+	switch (new_mode) {
+	case NIC_MULTICAST_BLOCKED:
+		ne2k_set_accept_mcast(ne2k, false);
+		nic_report_hw_filtering(nic_data, -1, 1, -1);
+		return EOK;
+	case NIC_MULTICAST_LIST:
+		ne2k_set_accept_mcast(ne2k, true);
+		ne2k_set_mcast_hash(ne2k,
+			nic_mcast_hash(address_list, address_count));
+		nic_report_hw_filtering(nic_data, -1, 0, -1);
+		return EOK;
+	case NIC_MULTICAST_PROMISC:
+		ne2k_set_accept_mcast(ne2k, true);
+		ne2k_set_mcast_hash(ne2k, 0xFFFFFFFFFFFFFFFFllu);
+		nic_report_hw_filtering(nic_data, -1, 1, -1);
+		return EOK;
+	default:
+		return ENOTSUP;
+	}
+}
+
+static int ne2k_on_broadcast_mode_change(nic_t *nic_data,
+	nic_broadcast_mode_t new_mode)
+{
+	ne2k_t *ne2k = (ne2k_t *) nic_get_specific(nic_data);
+	switch (new_mode) {
+	case NIC_BROADCAST_BLOCKED:
+		ne2k_set_accept_bcast(ne2k, false);
+		return EOK;
+	case NIC_BROADCAST_ACCEPTED:
+		ne2k_set_accept_bcast(ne2k, true);
+		return EOK;
+	default:
+		return ENOTSUP;
+	}
+}
+
+static int ne2k_dev_add(ddf_dev_t *dev)
+{
+	/* Allocate driver data for the device. */
+	nic_t *nic_data = nic_create_and_bind(dev);
+	if (nic_data == NULL)
+		return ENOMEM;
+	
+	nic_set_write_packet_handler(nic_data, ne2k_send);
+	nic_set_state_change_handlers(nic_data,
+		ne2k_on_activating, NULL, ne2k_on_stopping);
+	nic_set_filtering_change_handlers(nic_data,
+		ne2k_on_unicast_mode_change, ne2k_on_multicast_mode_change,
+		ne2k_on_broadcast_mode_change, NULL, NULL);
+	
+	ne2k_t *ne2k = malloc(sizeof(ne2k_t));
+	if (NULL != ne2k) {
+		memset(ne2k, 0, sizeof(ne2k_t));
+		nic_set_specific(nic_data, ne2k);
+	} else {
+		nic_unbind_and_destroy(dev);
+		return ENOMEM;
+	}
+	
+	int rc = ne2k_dev_init(nic_data);
+	if (rc != EOK) {
+		ne2k_dev_cleanup(dev);
+		return rc;
+	}
+	
+	rc = nic_report_address(nic_data, &ne2k->mac);
+	if (rc != EOK) {
+		ne2k_dev_cleanup(dev);
+		return rc;
+	}
+	
+	rc = nic_register_as_ddf_fun(nic_data, &ne2k_dev_ops);
+	if (rc != EOK) {
+		ne2k_dev_cleanup(dev);
+		return rc;
+	}
+	
+	rc = nic_connect_to_services(nic_data);
+	if (rc != EOK) {
+		ne2k_dev_cleanup(dev);
+		return rc;
+	}
+	
+	return EOK;
+}
+
+static nic_iface_t ne2k_nic_iface = {
+	.set_address = ne2k_set_address
+};
+
+static driver_ops_t ne2k_driver_ops = {
+	.dev_add = ne2k_dev_add
+};
+
+static driver_t ne2k_driver = {
+	.name = NAME,
+	.driver_ops = &ne2k_driver_ops
+};
+
+int main(int argc, char *argv[])
+{
+	nic_driver_init(NAME);
+	nic_driver_implement(&ne2k_driver_ops, &ne2k_dev_ops, &ne2k_nic_iface);
+	
+	return ddf_driver_main(&ne2k_driver);
+}
+
+/** @}
+ */
Index: uspace/drv/nic/ne2k/ne2k.ma
===================================================================
--- uspace/drv/nic/ne2k/ne2k.ma	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
+++ uspace/drv/nic/ne2k/ne2k.ma	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -0,0 +1,1 @@
+10 isa/ne2k
Index: uspace/drv/test/test1/test1.c
===================================================================
--- uspace/drv/test/test1/test1.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/test/test1/test1.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -40,5 +40,5 @@
 #include "test1.h"
 
-static int test1_add_device(ddf_dev_t *dev);
+static int test1_dev_add(ddf_dev_t *dev);
 static int test1_dev_remove(ddf_dev_t *dev);
 static int test1_dev_gone(ddf_dev_t *dev);
@@ -47,5 +47,5 @@
 
 static driver_ops_t driver_ops = {
-	.add_device = &test1_add_device,
+	.dev_add = &test1_dev_add,
 	.dev_remove = &test1_dev_remove,
 	.dev_gone = &test1_dev_gone,
@@ -141,5 +141,5 @@
  * @return Error code reporting success of the operation.
  */
-static int test1_add_device(ddf_dev_t *dev)
+static int test1_dev_add(ddf_dev_t *dev)
 {
 	ddf_fun_t *fun_a;
@@ -147,5 +147,5 @@
 	int rc;
 
-	ddf_msg(LVL_DEBUG, "add_device(name=\"%s\", handle=%d)",
+	ddf_msg(LVL_DEBUG, "dev_add(name=\"%s\", handle=%d)",
 	    dev->name, (int) dev->handle);
 
Index: uspace/drv/test/test2/test2.c
===================================================================
--- uspace/drv/test/test2/test2.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/test/test2/test2.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -40,5 +40,5 @@
 #define NAME "test2"
 
-static int test2_add_device(ddf_dev_t *dev);
+static int test2_dev_add(ddf_dev_t *dev);
 static int test2_dev_remove(ddf_dev_t *dev);
 static int test2_dev_gone(ddf_dev_t *dev);
@@ -47,5 +47,5 @@
 
 static driver_ops_t driver_ops = {
-	.add_device = &test2_add_device,
+	.dev_add = &test2_dev_add,
 	.dev_remove = &test2_dev_remove,
 	.dev_gone = &test2_dev_gone,
@@ -193,9 +193,9 @@
 }
 
-static int test2_add_device(ddf_dev_t *dev)
+static int test2_dev_add(ddf_dev_t *dev)
 {
 	test2_t *test2;
 
-	ddf_msg(LVL_DEBUG, "test2_add_device(name=\"%s\", handle=%d)",
+	ddf_msg(LVL_DEBUG, "test2_dev_add(name=\"%s\", handle=%d)",
 	    dev->name, (int) dev->handle);
 
Index: uspace/drv/test/test3/test3.c
===================================================================
--- uspace/drv/test/test3/test3.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/test/test3/test3.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -41,5 +41,5 @@
 #define NUM_FUNCS 20
 
-static int test3_add_device(ddf_dev_t *dev);
+static int test3_dev_add(ddf_dev_t *dev);
 static int test3_dev_remove(ddf_dev_t *dev);
 static int test3_fun_online(ddf_fun_t *fun);
@@ -47,5 +47,5 @@
 
 static driver_ops_t driver_ops = {
-	.add_device = &test3_add_device,
+	.dev_add = &test3_dev_add,
 	.dev_remove = &test3_dev_remove,
 	.fun_online = &test3_fun_online,
@@ -127,10 +127,10 @@
 }
 
-static int test3_add_device(ddf_dev_t *dev)
+static int test3_dev_add(ddf_dev_t *dev)
 {
 	int rc = EOK;
 	test3_t *test3;
 
-	ddf_msg(LVL_DEBUG, "add_device(name=\"%s\", handle=%d)",
+	ddf_msg(LVL_DEBUG, "dev_add(name=\"%s\", handle=%d)",
 	    dev->name, (int) dev->handle);
 
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/Makefile	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -67,5 +67,7 @@
 	generic/devman.c \
 	generic/device/hw_res.c \
+	generic/device/hw_res_parsed.c \
 	generic/device/char_dev.c \
+	generic/device/nic.c \
 	generic/elf/elf_load.c \
 	generic/event.c \
@@ -103,4 +105,5 @@
 	generic/adt/list.c \
 	generic/adt/hash_table.c \
+	generic/adt/hash_set.c \
 	generic/adt/dynamic_fifo.c \
 	generic/adt/measured_strings.c \
Index: uspace/lib/c/arch/ia64/include/ddi.h
===================================================================
--- uspace/lib/c/arch/ia64/include/ddi.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/lib/c/arch/ia64/include/ddi.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -52,8 +52,12 @@
 static inline void pio_write_8(ioport8_t *port, uint8_t v)
 {
-	uintptr_t prt = (uintptr_t) port;
+	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
+		uintptr_t prt = (uintptr_t) port;
 
-	*((ioport8_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+		*((ioport8_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+	} else {
+		*port = v;
+	}
 
 	asm volatile ("mf\n" ::: "memory");
@@ -62,8 +66,12 @@
 static inline void pio_write_16(ioport16_t *port, uint16_t v)
 {
-	uintptr_t prt = (uintptr_t) port;
+	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
+		uintptr_t prt = (uintptr_t) port;
 
-	*((ioport16_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+		*((ioport16_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+	} else {
+		*port = v;
+	}
 
 	asm volatile ("mf\n" ::: "memory");
@@ -72,8 +80,12 @@
 static inline void pio_write_32(ioport32_t *port, uint32_t v)
 {
-	uintptr_t prt = (uintptr_t) port;
+	if (port < (ioport32_t *) IO_SPACE_BOUNDARY) {
+		uintptr_t prt = (uintptr_t) port;
 
-	*((ioport32_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+		*((ioport32_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12)))) = v;
+	} else {
+		*port = v;
+	}
 
 	asm volatile ("mf\n" ::: "memory");
@@ -82,30 +94,54 @@
 static inline uint8_t pio_read_8(ioport8_t *port)
 {
-	uintptr_t prt = (uintptr_t) port;
+	uint8_t v;
 
 	asm volatile ("mf\n" ::: "memory");
 
-	return *((ioport8_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	if (port < (ioport8_t *) IO_SPACE_BOUNDARY) {
+		uintptr_t prt = (uintptr_t) port;
+
+		v = *((ioport8_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	} else {
+		v = *port;
+	}
+
+	return v;
 }
 
 static inline uint16_t pio_read_16(ioport16_t *port)
 {
-	uintptr_t prt = (uintptr_t) port;
+	uint16_t v;
 
 	asm volatile ("mf\n" ::: "memory");
 
-	return *((ioport16_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	if (port < (ioport16_t *) IO_SPACE_BOUNDARY) {
+		uintptr_t prt = (uintptr_t) port;
+
+		v = *((ioport16_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	} else {
+		v = *port;
+	}
+
+	return v;
 }
 
 static inline uint32_t pio_read_32(ioport32_t *port)
 {
-	uintptr_t prt = (uintptr_t) port;
+	uint32_t v;
 
 	asm volatile ("mf\n" ::: "memory");
 
-	return *((ioport32_t *)(IA64_IOSPACE_ADDRESS +
-	    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	if (port < (ioport32_t *) port) {
+		uintptr_t prt = (uintptr_t) port;
+
+		v = *((ioport32_t *)(IA64_IOSPACE_ADDRESS +
+		    ((prt & 0xfff) | ((prt >> 2) << 12))));
+	} else {
+		v = *port;
+	}
+
+	return v;
 }
 
